#ifndef BON_FILE
#define BON_FILE

#include <stdio.h>
#include "bonnie.h"
#include "bon_time.h"

class CFileOp
{
public:
  CFileOp();
  void set_size(int size);
  int open(CPCCHAR basename, bool create, bool fopen = false);
  ~CFileOp();
  int write_block_putc();
  int write_block(CPCVOID buf);
  int read_block_getc(char *buf);
  int read_block(PVOID buf);
  int seek(int offset, int whence);
  int doseek(long where, bool update);
  void close();
  int reopen(bool create, bool fopen = false);
private:
  int m_open(CPCCHAR basename, int ind, bool create);
  int m_chunks_per_file, m_total_chunks;
  int m_last_file_chunks;
  int m_cur_pos;
  int m_file_ind;
  FILE **m_stream;
  int *m_fd;
  int m_num_files;
  bool m_isopen;
  char *m_name;
  CFileOp(const CFileOp &f);
  CFileOp & operator =(const CFileOp &f);
};


#endif
